library ieee ;
use ieee.std_logic_1164.all ;
use ieee.std_logic_arith.all ;
use ieee.std_logic_signed.all ;

entity filtre_simple is
port 
	(R : in std_logic;
	 CLK	: in std_logic;
	 A	: in std_logic_vector(7 downto 0);
	 STOT	: out std_logic_vector(7 downto 0)
	 );
end filtre_simple;

architecture a_filtre_simple of filtre_simple is

component add8
	
	port( AA, BB: in Std_logic_vector(7 downto 0);
		SS : out Std_logic_vector(7 downto 0)
	     );

end component;

component seq8
	
	port( CLK,R: IN STD_LOGIC; 
                d : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                q: OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
             );

end component;



signal i1,i2,i3 : Std_logic_vector(7 downto 0);
signal tmp : std_logic_vector(7 downto 0);
signal tmpmult : std_logic_vector(7 downto 0);

begin 
  r1: seq8 port map (CLK=>CLK, R=>R, d=> A, q=>i1);

  i2 <= conv_std_logic_vector(signed (shr(i1,"00000001")),8);
  add: add8 port map (AA=>i2, BB=>tmpmult,SS=>i3);
  r2:seq8 port map (CLK=>CLK, R=>R, d=> i3, q=>tmp);

  tmpmult <= conv_std_logic_vector(signed(shr(tmp, "00000001")),8)
             +conv_std_logic_vector(signed(shr(tmp, "00000010")),8)
             +conv_std_logic_vector(signed(shr(tmp, "00000101")),8)
             +conv_std_logic_vector(signed(shr(tmp, "00000110")),8);
  stot <= tmp;
                   
end a_filtre_simple;
